############################################
#    XBMC4XBOX Skin Porting Tool v0.1.1    #
#  written by tim619 for xbmc4xbox forum   #
############################################

# Improvements are welcome BUT no OOP!
# This works only for 1080p skin source
# Note: Only run this on a fresh build
# if you run this multiple times on same
# folder width and height will get wrong
# (smaller) values!

import os, math


SkinFolderName = "conq" # Here goes the name


Path = os.path.dirname(os.path.realpath(__file__))
SkinPath = Path+"\\"+SkinFolderName

topStart = "<top>"
topStartLen = len(topStart)
bottomStart = "<bottom>"
bottomStartLen = len(bottomStart)
leftStart = "<left>"
leftStartLen = len(leftStart)
rightStart = "<right>"
rightStartLen = len(rightStart)
topEnd = "</top>"
topEndLen = len(topEnd)
bottomEnd = "</bottom>"
bottomEndLen = len(bottomEnd)
leftEnd = "</left>"
leftEndLen = len(leftEnd)
rightEnd = "</right>"
rightEndLen = len(rightEnd)
posyStart = "<posy>"
posxStart = "<posx>"
posyEnd = "</posy>"
posxEnd = "</posx>"
wStart = "<width>"
wStartLen = len(wStart)
wEnd = "</width>"
wEndLen = len(wEnd)
hStart = "<height>"
hStartLen = len(hStart)
hEnd = "</height>"
hEndLen = len(hEnd)

if not os.path.isdir(SkinPath):
	print("You have to set up the folder name!")
for root, dirs, files in os.walk(SkinPath):
	for file in files:
		if file.lower().endswith(".xml"):
			print(file)
			topIndex = 0
			bottomIndex = 0
			leftIndex = 0
			rightIndex = 0
			wIndex = 0
			hIndex = 0
			xmlFileWithPath = os.path.join(root, file)
			# <top></top>
			with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
				data = xmlFileLoaded.read()
			topFind = data.find(topStart, topIndex)
			topFindEnd = data.find(topEnd, topFind)
			while topFind != -1 and topFindEnd != -1:
				valueString = data[topFind+topStartLen:topFindEnd]
				if "." in valueString: #Author used float :\
					valueString = int(float(valueString))
				value = int(math.ceil(int(valueString)/1.5))
				if value > 720:
					value = 720
				elif value < 0:
					value = 0
				else:
					pass
				value = str(value)
				dataNew = data[:topFind] + posyStart + value + posyEnd + data[topFindEnd+topEndLen:]
				with open(xmlFileWithPath, "w", encoding = "UTF8") as xmlNew:
					xmlNew.write(dataNew)
				with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
					data = xmlFileLoaded.read()
				topIndex = topFind + 3
				topFind = data.find(topStart, topIndex)
				topFindEnd = data.find(topEnd, topFind)
			# <bottom></bottom>
			with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
				data = xmlFileLoaded.read()
			bottomFind = data.find(bottomStart, bottomIndex)
			bottomFindEnd = data.find(bottomEnd, bottomFind)
			while bottomFind != -1 and bottomFindEnd != -1:
				valueString = data[bottomFind+bottomStartLen:bottomFindEnd]
				if "." in valueString: #Author used float :\
					valueString = int(float(valueString))
				value = 720 - int(math.ceil(int(valueString)/1.5))
				if value > 720:
					value = 720
				elif value < 0:
					value = 0
				else:
					pass
				value = str(value)
				dataNew = data[:bottomFind] + posyStart + value + posyEnd + data[bottomFindEnd+bottomEndLen:]
				with open(xmlFileWithPath, "w", encoding = "UTF8") as xmlNew:
					xmlNew.write(dataNew)
				with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
					data = xmlFileLoaded.read()
				bottomIndex = bottomFind + 5
				bottomFind = data.find(bottomStart, bottomIndex)
				bottomFindEnd = data.find(bottomEnd, bottomFind)
			# <left></left>
			with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
				data = xmlFileLoaded.read()
			leftFind = data.find(leftStart, leftIndex)
			leftFindEnd = data.find(leftEnd, leftFind)
			while leftFind != -1 and leftFindEnd != -1:
				valueString = data[leftFind+leftStartLen:leftFindEnd]
				if "." in valueString: #Author used float :\
					valueString = int(float(valueString))
				value = int(math.ceil(int(valueString)/1.5))
				if value > 1280:
					value = 1280
				elif value < 0:
					value = 0
				else:
					pass
				value = str(value)
				dataNew = data[:leftFind] + posxStart + value + posxEnd + data[leftFindEnd+leftEndLen:]
				with open(xmlFileWithPath, "w", encoding = "UTF8") as xmlNew:
					xmlNew.write(dataNew)
				with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
					data = xmlFileLoaded.read()
				leftIndex = leftFind + 1
				leftFind = data.find(leftStart, leftIndex)
				leftFindEnd = data.find(leftEnd, leftFind)
			# <right></right>
			with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
				data = xmlFileLoaded.read()
			rightFind = data.find(rightStart, rightIndex)
			rightFindEnd = data.find(rightEnd, rightFind)
			while rightFind != -1 and rightFindEnd != -1:
				valueString = data[rightFind+rightStartLen:rightFindEnd]
				if "." in valueString: #Author used float :\
					valueString = int(float(valueString))
				value = 1280 - int(math.ceil(int(valueString)/1.5))
				if value > 1280:
					value = 1280
				elif value < 0:
					value = 0
				else:
					pass
				value = str(value)
				dataNew = data[:rightFind] + posxStart + value + posxEnd + data[rightFindEnd+rightEndLen:]
				with open(xmlFileWithPath, "w", encoding = "UTF8") as xmlNew:
					xmlNew.write(dataNew)
				with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
					data = xmlFileLoaded.read()
				rightIndex = rightFind + 3
				rightFind = data.find(rightStart, rightIndex)
				rightFindEnd = data.find(rightEnd, rightFind)
			# <width></width>
			with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
				data = xmlFileLoaded.read()
			wFind = data.find(wStart, wIndex)
			wFindEnd = data.find(wEnd, wFind)
			while wFind != -1 and wFindEnd != -1:
				valueString = data[wFind+wStartLen:wFindEnd]
				if valueString.lower() == "auto" or valueString == "-":
					with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
						data = xmlFileLoaded.read()
					wIndex = wFind + 5
					wFind = data.find(wStart, wIndex)
					wFindEnd = data.find(wEnd, wFind)
					break
				else:
					if "." in valueString: #Author used float :\
						valueString = int(float(valueString))	
					value = int(math.ceil(int(valueString)/1.5))
					if value > 1280:
						value = 1280
					elif value < 0:
						value = 0
					else:
						pass
					value = str(value)
					dataNew = data[:wFind+wStartLen] + value + data[wFindEnd:]
					with open(xmlFileWithPath, "w", encoding = "UTF8") as xmlNew:
						xmlNew.write(dataNew)
					with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
						data = xmlFileLoaded.read()
					wIndex = wFind + 5
					wFind = data.find(wStart, wIndex)
					wFindEnd = data.find(wEnd, wFind)
			# <height></height>
			with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
				data = xmlFileLoaded.read()
			hFind = data.find(hStart, hIndex)
			hFindEnd = data.find(hEnd, hFind)
			while hFind != -1 and hFindEnd != -1:
				valueString = data[hFind+hStartLen:hFindEnd]
				if valueString.lower() == "auto" or valueString == "-":
					with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
						data = xmlFileLoaded.read()
					hIndex = hFind + 5
					hFind = data.find(hStart, hIndex)
					hFindEnd = data.find(hEnd, hFind)
					break
				else:
					if "." in valueString: #Author used float :\
						valueString = int(float(valueString))
					value = int(math.ceil(int(valueString)/1.5))
					if value > 720:
						value = 720
					elif value < 0:
						value = 0
					else:
						pass
					value = str(value)
					dataNew = data[:hFind+hStartLen] + value + data[hFindEnd:]
					with open(xmlFileWithPath, "w", encoding = "UTF8") as xmlNew:
						xmlNew.write(dataNew)
					with open(xmlFileWithPath, "r", encoding = "UTF8") as xmlFileLoaded:
						data = xmlFileLoaded.read()
					hIndex = hFind + 5
					hFind = data.find(hStart, hIndex)
					hFindEnd = data.find(hEnd, hFind)